#!/usr/bin/perl

#
# Gateway Board : init.cgi - 2014/03/23
# Copyright (c) KentWeb
# http://www.kent-web.com/
#
# REBUILD()
#
#  Gateway Board v5.0 PLUS 2014/03/24
#  Edited by Hamel(TRANSFORM) Since 2012
#  https://www.transformsite.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);
use lib "./lib";
use CGI::Minimal;
use Crypt::RC4;

# ݒt@CF
require "./init.cgi";
my %cf = init();

# f[^
CGI::Minimal::max_read_size($cf{maxdata});
my $cgi = CGI::Minimal->new;
error('eʃI[o[') if ($cgi->truncated);
my %in = parse_form($cgi);

# F
check_passwd();

# 
if ($in{mode} eq 'del_log') { del_log(); }
if ($in{mode} eq 'edit_log') { edit_log(); }
if ($in{mode} eq 'res') { res_form(); }
if ($in{mode} eq 'pform') { p_form(); }
if ($in{mode_form}) { form_page(); }
if ($in{mode_regi}) { regist(); }
if ($in{mode_find}) { find_data(); }
if ($in{mode_note}) { note_page(); }
bbs_list();

#-----------------------------------------------------------
#  L\
#-----------------------------------------------------------
sub bbs_list {
	# X
	my ($res,$pg,%res);
	foreach ( keys %in ) {
		if (/^res:(\d+)$/) {
			$res = $1;
			last;
		} elsif (/^pg:(\d+)$/) {
			$pg = $1;
			last;
		}
	}
	if ($res) {
		my $flg;
		open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
		while (<IN>) {
			my ($no,$sub,$com,$ex) = (split(/<>/))[0,4,5,12];
			if ($res == $no) {
				$flg++;
				$res{sub} = $sub;
				$res{com} = $com;
				$res{ex} = $ex;
				last;
			}
		}
		close(IN);

		if (!$flg) { error("YL܂"); }

		$res{sub} =~ s/^Re://g;
		$res{sub} =~ s/\[\d+\]\s?//g;
		$res{sub} = "Re:[$res] $res{sub}";
		$res{com} = "&gt; $res{com}";
		$res{com} =~ s/<br>/\n&gt; /ig;
	}
	res_form($res) if ($res);

	# y[W`
	$pg ||= 0;

	# f[^I[v
	my ($i,@log);
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{pg_max});

		push(@log,$_);
	}
	close(IN);

	# Jz{^쐬
	my $page_btn = make_pgbtn($i,$pg);

	# NbL[擾
	my @cook = get_cookie();
	$cook[2] ||= 'http://';

	# FI{^
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	# ev[gǍ
	open(IN,"$cf{tmpldir}/bbs.html") or error("open err: bbs.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/gwbbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		error("ev[gsł");
	}

	# u
	foreach ($head,$foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!homepage!/$cf{homepage}/g;
		s/!page_btn!/$page_btn/g;
		s/!name!/$cook[0]/;
		s/!email!/$cook[1]/;
		s/!url!/$cook[2]/;
		s/!sub!/$res{sub}/;
		s/!comment!/$res{com}/;
		s/!color!/$color/g;
		s/!new_mark!/$cf{new_mark}/g;
		s/!new_time!/$cf{new_time}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
		s/!id!/$in{id}/g;
		s/!pw!/$in{pw}/g;
		s/!ptop-icon!/<img src="$cf{ico_ptop}" alt="pagetop">/g;
	}

	# wb_\
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	# [v
	foreach (@log) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$tim,$id,$col,$ex,$w,$h,$chk) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$com = autolink($com) if ($cf{autolink});
		$com =~ s/([>]|^)(&gt;[^<]*)/$1<span style="color:$cf{ref_col}">$2<\/span>/g if ($cf{ref_col});
		#if ($url) {
		#	$url = "http://$url" if ($url !~ /^http:/);
		#	$com .= qq|<p class="url"><a href="$url" target="_blank">$url</a></p>|;
		#}
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;

		# 莞Ԉȓ̓e[NEW}[N]\
		my $time = time;
		my $newsign;
		if ($time - $tim > $cf{new_time} * 3600) { $newsign = ""; }
		else { $newsign = $cf{new_mark}; }

		# Yt
		my $clip;
		if ($ex) {
			# mF҂
			if ($cf{imgcheck} && $chk != 1) {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$com .= qq|<p>[Yt]: Fؑ҂ ($size)</p>|;

			# Yt摜
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{imgdir}/$no-s$ex") {
					$op = qq|src="$cf{imgurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{imgurl}/$no$ex" width="$w" height="$h"|;
				}
				#$com .= qq|<p><a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0"></a></p>|;

			# 摜̓Rg̉
			if ($cf{imgpoint} == 1) {
				$com .= qq|<p><a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0" class="snapshot"></a></p>|;
			# 摜̓Rg̍i荞݁j
			} else {
				$com = qq|<a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0" align="left" hspace="18" class="snapshot"></a>$com<br clear="all">|;
			}

			# 摜ȊO
			} else {
				my $size = get_size("$cf{imgdir}/$no$ex");
				$clip = qq|<p>Yt: <a href="$cf{imgurl}/$no$ex" target="_blank"><img src="$cf{ico_clip}" class="clip"></a> ($size)</p>|;
			}
		}

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!pwd!/$pw/g;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!date!/$date $newsign/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s|!comment!|<span style="color:$col[$col]">$com</span>|g;
		$tmp =~ s/!new_mark!/$cf{new_mark}/g;
		$tmp =~ s/!new_time!/$cf{new_time}/g;
		$tmp =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
		$tmp =~ s/!id!/$in{id}/g;
		$tmp =~ s/!pw!/$in{pw}/g;
		$tmp =~ s/!myid!/$id/g;
		$tmp =~ s/<!-- clip -->/$clip/;
		#$tmp =~ s|!ico_edit!|<a href="$cf{bbs_cgi}?mode=p_form&no=$no"><img src="$cf{iconurl}/pg_edit02.gif" alt="LҏW"></a>|g;
		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  etH[
#-----------------------------------------------------------
sub form_page {

	# NbL[擾
	my @cook = &get_cookie;
	$cook[2] ||= 'http://';

	# FI{^
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	open(IN,"$cf{tmpldir}/form.html") or &error("open err: form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# u
	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!name!/$cook[0]/;
	$tmpl =~ s/!email!/$cook[1]/;
	$tmpl =~ s/!url!/$cook[2]/;
	$tmpl =~ s/!sub!/$in{sub}/;
	$tmpl =~ s/!comment!/$in{comment}/;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/!id!/$in{id}/g;
	$tmpl =~ s/!pw!/$in{pw}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/gwbbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;

	# tb^
	footer();

	exit;
}

#-----------------------------------------------------------
#  ԐMtH[
#-----------------------------------------------------------
sub res_form {

	my $res = shift;
	# X
	my ($res,$pg,%res);
	foreach ( keys(%in) ) {
		if (/^res:(\d+)$/) {
			$res = $1;
			last;
		} elsif (/^pg:(\d+)$/) {
			$pg = $1;
			last;
		}
	}
	if ($res) {
		my $flg;
		open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
		while (<IN>) {
			my ($no,$sub,$com,$ex) = (split(/<>/))[0,4,5,12];
			if ($res == $no) {
				$flg++;
				$res{sub} = $sub;
				$res{com} = $com;
				$res{ex} = $ex;
				last;
			}
		}
		close(IN);

		if (!$flg) { &error("YL܂"); }

		$res{sub} =~ s/^Re://g;
		$res{sub} =~ s/\[\d+\]\s?//g;
		$res{sub} = "Re:[$res] $res{sub}";
		$res{com} = "&gt; $res{com}";
		$res{com} =~ s/<br>/\n&gt; /ig;
	}

	# y[W`
	$pg ||= 0;

	# f[^I[v
	my ($i,@log);
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	while (<IN>) {
		$i++;
		next if ($i < $pg + 1);
		next if ($i > $pg + $cf{pg_max});

		push(@log,$_);
	}
	close(IN);

	# NbL[擾
	my @cook = get_cookie($cf{cookie_id});
	$cook[2] ||= 'http://';

	# FI{^
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $cook[3]) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	# ev[gǍ
	open(IN,"$cf{tmpldir}/read.html") or &error("open err: read.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/gwbbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# s
	my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$tim,$id,$col,$ex,$w,$h,$chk) = split(/<>/);
	$com =~ s/<br>/\n/g;

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		&error("ev[gsł");
	}

	# u
	foreach ($head,$foot) {
		s/!([a-z]+_cgi)!/$cf{$1}/g;
		s/!name!/$cook[0]/;
		s/!email!/$cook[1]/;
		s/!url!/$cook[2]/;
		s/!sub!/$res{sub}/;
		s/!color!/$color/g;
		s/!comment!/$res{com}/;
		s/!id!/$in{id}/g;
		s/!pw!/$in{pw}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
	}

	# wb_\
	print "Content-type: text/html\n\n";
	print $head;

	# [v
	foreach (@log) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$tim,$id,$col,$ex,$w,$h,$chk) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$com = &autolink($com) if ($cf{autolink});
		$com =~ s/([>]|^)(&gt;[^<]*)/$1<span style="color:$cf{ref_col}">$2<\/span>/g if ($cf{ref_col});
		$com = qq|<span style="color:$col[$col]">$com</span>|;
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;
		#if ($url) {
		#	$url = "http://$url" if ($url !~ /^http:/);
		#	$com .= qq|<p class="url"><a href="$url" target="_blank">$url</a></p>|;
		#}

		# 莞Ԉȓ̓e[NEW}[N]\
		my $time = time;
		my $newsign;
		if ($time - $tim > $cf{new_time} * 3600) { $newsign = ""; }
		else { $newsign = $cf{new_mark}; }

		# Yt
		if ($ex) {
			# mF҂
			if ($cf{imgcheck} && $chk != 1) {
				my $size = -s "$cf{imgdir}/$no$ex" || 0;
				$com .= qq|<p>[Yt]: Fؑ҂ ($size Bytes)</p>|;

			# Yt摜
			} elsif ($ex =~ /jpg$|gif$|png$/) {
				my $op;
				if (-f "$cf{imgdir}/$no-s$ex") {
					$op = qq|src="$cf{imgurl}/$no-s$ex"|;
				} else {
					($w,$h) = &resize($w,$h);
					$op = qq|src="$cf{imgurl}/$no$ex" width="$w" height="$h"|;
				}
				#$com .= qq|<p><a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0"></a></p>|;

			# 摜̓Rg̉
			if ($cf{imgpoint} == 1) {
				$com .= qq|<p><a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0"></a></p>|;
			# 摜̓Rg̍i荞݁j
			} else {
				$com = qq|<a href="$cf{imgurl}/$no$ex" target="_blank"><img $op border="0" align="left" hspace="18"></a>$com<br clear="all">|;
			}

			# 摜ȊO
			} else {
				my $size = -s "$cf{imgdir}/$no$ex" || 0;
				$com .= qq|<p>Yt: <a href="$cf{imgurl}/$no$ex" target="_blank"><img src="$cf{ico_clip}" class="clip"></a> ($size Bytes)</p>|;
			}
		}

		my $tmp = $loop;
		$tmp =~ s/!num!/$no/g;
		$tmp =~ s/!sub!/$sub $newsign/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/!comment!/$com/g;
		$tmp =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
		$tmp =~ s/!id!/$in{id}/g;
		$tmp =~ s/!pw!/$in{pw}/g;
		$tmp =~ s/!myid!/$id/g;
		print $tmp;
	}

	# tb^
	&footer($foot);
}

#-----------------------------------------------------------
#  pX[htH[
#-----------------------------------------------------------
sub p_form {

	$in{num} =~ s/\D//g;

	# NbL[擾
	my @cook = &get_cookie;
	$cook[2] ||= 'http://';

	# L
	my ($name,$pwd);
	open(DAT,"+< $cf{logfile}") || &error("Open Error: $cf{logfile}");
	eval "flock(DAT, 2);";
	while (<DAT>) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$tim,$id,$col,$ex,$w,$h,$chk) = split(/<>/);

	if ($in{num} == $no) {
		$name = $name;
		$sub = $sub;
		$pwd = $pw;
		last;
		}
	}
	close(DAT);

	# pX[hݒ
	&error("̋L̓pX[hݒ̂ߕҏWł܂") if ($pwd eq '');

	my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$tim,$id,$col,$ex,$w,$h,$chk) = split(/<>/);

	my @col = split(/\s+/, $cf{colors});

		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$com = &autolink($com) if ($cf{autolink});
		$com =~ s/([>]|^)(&gt;[^<]*)/$1<span style="color:$cf{ref_col}">$2<\/span>/g if ($cf{ref_col});
		$com = qq|<span style="color:$col[$col]">$com</span>|;
		$url &&= qq|<a href="$url" target="_blank"><img src="$cf{ico_home}" class="icon"></a>|;
		if (length($com) > 135) { $com = substr($com,0,130); $com .= '.....()'; }

		# Yt
		my $clip;
		if ($ex) {
			my $size = get_size("$cf{imgdir}/$no$ex");
			if ($cf{imgcheck} && $chk != 1) {
				$clip = qq|<div class="clip">[Yt]: Fؑ҂ ($size)</div>|;
			} else {
				$clip = qq|<div class="clip">[Yt]: <a href="$cf{imgurl}/$no$ex" target="_blank">$no$ex</a> ($size)</div>|;
			}
		}

	open(IN,"$cf{tmpldir}/p_form.html") or &error("open err: p_form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	# u
	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/gwbbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!no!/$in{num}/g;
	$tmpl =~ s/!pwd!/$pw/g;
	$tmpl =~ s/!sub!/$sub/g;
	$tmpl =~ s/!date!/$date/g;
	$tmpl =~ s/!name!/$name/g;
	$tmpl =~ s/!home!/$url/g;
	$tmpl =~ s/!comment!/$com/g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!id!/$in{id}/g;
	$tmpl =~ s/!pw!/$in{pw}/g;
	$tmpl =~ s/<!-- clip -->/$clip/;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;

	# tb^
	footer();

	exit;
}

#-----------------------------------------------------------
#  L
#-----------------------------------------------------------
sub regist {
	# e`FbN
	if ($cf{postonly} && $ENV{REQUEST_METHOD} ne 'POST') {
		error("sȃNGXgł");
	}

	# svsJbg
	$in{sub}  =~ s/<br>//g;
	$in{name} =~ s/<br>//g;
	$in{pwd}  =~ s/<br>//g;
	$in{comment} =~ s/(<br>)+$//g;

	# `FbN
	if ($cf{no_wd}) { no_wd(); }
	if ($cf{jp_wd}) { jp_wd(); }
	if ($cf{urlnum} > 0) { urlnum(); }

	# ͂̏ꍇ
	if ($in{url} eq "http://") { $in{url} = ""; }
	$in{sub} ||= '';

	# tH[e`FbN
	my $err;
	if ($in{name} eq "") { $err .= "O͂Ă܂<br>"; }
	if ($in{comment} eq "") { $err .= "Rg͂Ă܂<br>"; }
	if ($in{email} ne '' && $in{email} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,6}$/) {
		$err .= "d[͓̓esł<br>";
	}
	if ($in{url} ne '' && $in{url} !~ /^https?:\/\/[\w-.!~*'();\/?:\@&=+\$,%#]+$/) {
		$err .= "QƐURL͓̓esł<br>";
	}
	if ($err) { error($err); }

	# R[hϊ
	if ($cf{chg_code} == 1) {
		require './lib/Jcode.pm';
		$in{name} = Jcode->new($in{name})->sjis;;
		$in{sub}  = Jcode->new($in{sub})->sjis;
		$in{comment} = Jcode->new($in{comment})->sjis;
	}
	
	# zXg擾
	my ($host,$addr) = get_host();

	# 폜L[Í
	my $pwd = encrypt($in{pwd}) if ($in{pwd} ne "");

	# Ԏ擾
	my $time = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	my @wk = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
	my $date = sprintf("%04d/%02d/%02d(%s) %02d:%02d",
				$year+1900,$mon+1,$mday,$wk[$wday],$hour,$min);

	# 擪Lǂݎ
	open(DAT,"+< $cf{logfile}") or error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	my $top = <DAT>;

	# de`FbN
	my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$id) = split(/<>/, $top);
	if ($in{name} eq $nam && $in{comment} eq $com) {
		close(DAT);
		error("de͋֎~ł");
	}

	# Ae`FbN
	my $flg;
	if ($cf{regCtl} == 1) {
		if ($host eq $hos && $time - $tim < $cf{wait}) { $flg = 1; }
	} elsif ($cf{regCtl} == 2) {
		if ($time - $tim < $cf{wait}) { $flg = 1; }
	}
	if ($flg) {
		close(DAT);
		error("ݓełB΂炭Ă瓊e肢܂");
	}

	# LNo̔
	$no++;

	# t@CYt
	my ($ext,$w,$h) = upload($no) if ($in{upfile});

	# L
	my @data = ($top);
	my $i = 0;
	while (<DAT>) {
		$i++;
		push(@data,$_);

		last if ($i >= $cf{maxlog}-1);
	}

	# XV
	seek(DAT, 0, 0);
	print DAT "$no<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$pwd<>$time<>$in{id}<>$in{color}<>$ext<>$w<>$h<>0<>\n";
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# NbL[i[
	set_cookie($in{name},$in{email},$in{url},$in{color}) if ($in{cookie} == 1);

	# [ʒm
	my $clip = "$no$ext" if ($ext);
	mail_to($date,$host,$clip) if ($cf{mailing} == 1);

	# 
	message("肪Ƃ܂BL󗝂܂B");
}

#-----------------------------------------------------------
#  [h
#-----------------------------------------------------------
sub find_data {
	# 
	$in{cond} =~ s/\D//g;

	# v_E
	my %op = (1 => 'AND', 0 => 'OR');
	my $op_cond;
	foreach (1,0) {
		if ($in{cond} eq $_) {
			$op_cond .= qq|<option value="$_" selected>$op{$_}\n|;
		} else {
			$op_cond .= qq|<option value="$_">$op{$_}\n|;
		}
	}

	# s
	if ($cf{chg_code} == 1) {
		require './lib/Jcode.pm';
		$in{word} = Jcode->new($in{word})->sjis;
	}
	my @log = search($in{word},$in{cond}) if ($in{word} ne '');

	# ev[g
	open(IN,"$cf{tmpldir}/find.html") or error("open err: find.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/gwbbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	# 
	$tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s;
	my ($head,$loop,$foot) = ($1,$2,$3);

	foreach ($head, $foot) {
		s/!bbs_cgi!/$cf{bbs_cgi}/g;
		s/<!-- op_cond -->/$op_cond/;
		s/!word!/$in{word}/;
		s/!id!/$in{id}/g;
		s/!pw!/$in{pw}/g;
		s/!bbs_title!/$cf{bbs_title}/g;
	}

	# wb_
	print "Content-type: text/html; charset=shift_jis\n\n";
	print $head;

	# [v
	foreach my $log (@log) {
		my ($no,$date,$name,$eml,$sub,$com,$url,$host,$pw,$tim,$id,$col,$ex,$w,$h,$chk) = split(/<>/, $log);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);
		$com = autolink($com) if ($cf{autolink});
		$com =~ s/([>]|^)(&gt;[^<]*)/$1<span style="color:$cf{ref_col}">$2<\/span>/g if ($cf{ref_col});
		if ($url) {
			$url = "http://$url" if ($url !~ /^http:/);
			$url = qq|<a href="$url" target="_blank">$url</a>|;
		}

		# Yt
		my $clip;
		if ($ex) {
			my $size = get_size("$cf{imgdir}/$no$ex");
			if ($cf{imgcheck} && $chk != 1) {
				$clip = qq|<div class="clip">[Yt]: Fؑ҂ ($size)</div>|;
			} else {
				$clip = qq|<div class="clip">[Yt]: <a href="$cf{imgurl}/$no$ex" target="_blank">$no$ex</a> ($size)</div>|;
			}
		}

		my $tmp = $loop;
		$tmp =~ s/!sub!/$sub/g;
		$tmp =~ s/!date!/$date/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!home!/$url/g;
		$tmp =~ s/!comment!/$com/g;
		$tmp =~ s/!id!/$id/g;
		$tmp =~ s/<!-- clip -->/$clip/;
		print $tmp;
	}

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  s
#-----------------------------------------------------------
sub search {
	my ($word,$cond) = @_;

	# L[[hz
	$word =~ s/\x81\x40/ /g;
	my @wd = split(/\s+/, $word);

	# L[[hiShift-JIS`j
	my $ascii = '[\x00-\x7F]';
	my $hanka = '[\xA1-\xDF]';
	my $kanji = '[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]';

	# 
	my @log;
	open(IN,"$cf{logfile}") or error("open err: $cf{logfile}");
	while (<IN>) {
		my ($no,$date,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$id,$col,$ex,$w,$h,$chk) = split(/<>/);

		my $flg;
		foreach my $wd (@wd) {
			if ("$nam $eml $sub $com $url" =~ /^(?:$ascii|$hanka|$kanji)*?\Q$wd\E/i) {
				$flg++;
				if ($cond == 0) { last; }
			} else {
				if ($cond == 1) { $flg = 0; last; }
			}
		}
		next if (!$flg);

		push(@log,$_);
	}
	close(IN);

	# 
	return @log;
}

#-----------------------------------------------------------
#  ӎ\
#-----------------------------------------------------------
sub note_page {
	open(IN,"$cf{tmpldir}/note.html") or error("open err: note.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/gwbbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!id!/$in{id}/g;
	$tmpl =~ s/!pw!/$in{pw}/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  YtAbv[h
#-----------------------------------------------------------
sub upload {
	my $no = shift;

	# TlC@\
	require './lib/thumb.pl' if ($cf{thumbnail});

	# gq擾
	my $ext = $cgi->param_filename('upfile') =~ /(\.[^\\\/:\.]+)$/ ? $1 : error("gqs");
	$ext =~ tr/A-Z/a-z/;
	if ($ext eq '.jpeg') { $ext = '.jpg'; }

	# t@C`FbN
	check_upl($ext);

	# Ytt@C`
	my $upfile = "$cf{imgdir}/$no$ext";

	# Abv[h
	open(UP,"+> $upfile") or error("up err: $upfile");
	binmode(UP);
	print UP $in{upfile};
	close(UP);

	chmod(0666, $upfile);

	# 摜TCY擾
	my ($flg,$w,$h);
	if ($ext eq ".jpg") { ($w,$h) = &j_size($upfile); $flg++; }
	elsif ($ext eq ".gif") { ($w,$h) = &g_size($upfile); $flg++; }
	elsif ($ext eq ".png") { ($w,$h) = &p_size($upfile); $flg++; }

	# TlC
	if ($flg && $cf{thumbnail}) {
		($w,$h) = &resize($w,$h);
		my $thumb = "$cf{imgdir}/$no-s$ext";
		make_thumb($upfile,$thumb,$w,$h);
	}

	# ʂԂ
	return ($ext,$w,$h);
}

#-----------------------------------------------------------
#  [UL폜
#-----------------------------------------------------------
sub del_log {
	# ̓`FbN
	if ($in{num} eq '' || $in{pwd} eq '') {
		error("폜No܂͍폜L[̓ł");
	}

	my ($flg,$crypt,@log);
	open(DAT,"+< $cf{logfile}") or error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	while (<DAT>) {
		my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$id) = split(/<>/);
		if ($in{num} == $no) {
			$flg++;
			$crypt = $pw;
			next;
		}
		push(@log,$_);
	}

	if (!$flg || $crypt eq '') {
		close(DAT);
		error("폜L[ݒ肳ĂȂ͋L܂");
	}

	# 폜L[ƍ
	if (decrypt($in{pwd}, $crypt) != 1) {
		close(DAT);
		error("F؂ł܂");
	}

	# OXV
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);

	message("L폜܂");
}

#-----------------------------------------------------------
#  [ULC
#-----------------------------------------------------------
sub edit_log {
	# ̓`FbN
	if ($in{num} eq '' || $in{pwd} eq '') {
		&error("LNo͈Ï؃L[͂Ă܂");
	}

	# s
	if ($in{job} eq "edit") {

	# `FbN
	if ($cf{no_wd}) { &no_wd; }
	if ($cf{jp_wd}) { &jp_wd; }
	if ($cf{urlnum} > 0) { &urlnum; }

	# ͂̏ꍇ
	if ($in{url} eq "http://") { $in{url} = ""; }
	$in{sub} ||= '';

	# tH[e`FbN
	my $err;
	if ($in{name} eq "") { $err .= "O͂Ă܂<br>"; }
	if ($in{comment} eq "") { $err .= "Rg͂Ă܂<br>"; }
	if ($in{email} ne '' && $in{email} !~ /^[\w\.\-]+\@[\w\.\-]+\.[a-zA-Z]{2,}$/) {
		$err .= "d[͓̓esł<br>";
	}
	if ($in{url} ne '' && $in{url} !~ /^https?:\/\/[\w-.!~*'();\/?:\@&=+\$,%#]+$/) {
		$err .= "QƐURL͓̓esł<br>";
	}
	if ($err) { &error($err); }

	# R[hϊ
	if ($cf{chg_code} == 1) {
		require './lib/Jcode.pm';
		$in{name} = Jcode->new($in{name})->sjis;;
		$in{sub}  = Jcode->new($in{sub})->sjis;
		$in{comment} = Jcode->new($in{comment})->sjis;
	}

	my ($flg, $ext2,$w2,$h2, @data);
	open(DAT,"+< $cf{logfile}") || &error("Open Error: $cf{logfile}");
	eval "flock(DAT, 2);";
	while (<DAT>) {
		my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$id,$col,$ext,$w,$h) = split(/<>/);

		if ($in{num} == $no) {

		         $flg = 1;

			# Abv[h
			if ($in{upfile}) {
				($ext2,$w2,$h2) = &upload($in{num});
			}

			# 摜폜
			if ($in{imgdel}) {
				unlink("$cf{imgdir}/$in{num}$ext");
				$ext = $w = $h = '';
			}

			# YtAbv[h̏ꍇ
			if ($ext2) {
				# gqύX̏ꍇt@C폜
				if ($ext && $ext2 ne $ext) {
					unlink("$cf{imgdir}/$in{num}$ext");
				}
				# VYtt@C
				($ext,$w,$h) = ($ext2,$w2,$h2);
			}

		         $_ = "$no<>$dat<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$hos<>$pw<>$tim<>$in{id}<>$in{color}<>$ext<>$w<>$h<>0<>\n";
	}
	push(@data,$_);
	}

	if ($flg != 1) {
		close(DAT);
		&error("sȏł");
	}

	# XV
	seek(DAT, 0, 0);
	print DAT @data;
	truncate(DAT, tell(DAT));
	close(DAT);

	# bZ[W
	&message("L̏C܂");
}

	my ($flg, @edit);
	open(IN,"$cf{logfile}") || &error("Open Error: $cf{logfile}");
	while (<IN>) {
		my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$id,$col,$ext,$w,$h) = split(/<>/);

		if ($in{num} == $no) {

			# Ï؃L[Ȃ
			if ($pw eq '') {
				$flg = 2;
			} elsif

			# Ï؃L[v
			(&decrypt($in{pwd}, $pw) == 1) {
				$flg = 1;
				@edit = ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$id,$col,$ext,$w,$h);

			# Ï؃L[sv
			} else {
				$flg = 3;
			}
			last;
		}
	}
	close(IN);

	if (!$flg) {
		close(DAT);
		&error("YL܂");
	} elsif ($flg == 2) {
		close(DAT);
		&error("̋Lɂ͈Ï؃L[ݒ肳Ă܂");
	} elsif ($flg == 3) {
		close(DAT);
		&error("Ï؃L[Ⴂ܂");
	}

	# s
	my ($no,$dat,$nam,$eml,$sub,$com,$url,$hos,$pw,$tim,$id,$col,$ex) = split(/<>/);
	$com =~ s/<br>/\n/g;
	$url ||= "http://";

	# FI{^
	my @col = split(/\s+/, $cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ == $col) {
			$color .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_">|;
		}
		$color .= qq|<span style="color:$col[$_]"></span>\n|;
	}

	# Ytt@C
	my $attach;
	if ($ex) {
		$attach .= qq|&nbsp; [<a href="$cf{imgdir}/$no$ex" target="_blank">Yt</a>]\n|;
		$attach .= qq|<input type="checkbox" name="imgdel" value="1">폜\n|;
	}

	# CtH[
	open(IN,"$cf{tmpldir}/edit.html") or &error("open err: edit.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!([a-z]+_cgi)!/$cf{$1}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!icon:(\w+\.\w+)!|<img src="$cf{cmnurl}/$1" alt="" class="icon" />|g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/gwbbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!num!/$no/g;
	$tmpl =~ s/!pwd!/$pw/g;
	$tmpl =~ s/!name!/$nam/;
	$tmpl =~ s/!email!/$eml/;
	$tmpl =~ s/!url!/$url/;
	$tmpl =~ s/!sub!/$sub/;
	$tmpl =~ s/!comment!/$com/g;
	$tmpl =~ s/!color!/$color/g;
	$tmpl =~ s/!id!/$in{id}/g;
	$tmpl =~ s/!pw!/$in{pw}/g;
	$tmpl =~ s/<!-- attach -->/$attach/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;

	# tb^
	footer();

	exit;
}

#-----------------------------------------------------------
#  G[
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/gwbbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  [M
#-----------------------------------------------------------
sub mail_to {
	my ($date,$host,$clip) = @_;

	# MIMEGR[h
	if ($cf{chg_code} == 0) {
		require './lib/Jcode.pm';
	}
	my $msub = Jcode->new("$cf{version} : $in{sub}",'sjis')->mime_encode;

	# Rg̉s
	my $com = $in{comment};
	$com =~ s/<br>/\n/g;
	$com =~ s/&lt;/>/g;
	$com =~ s/&gt;/</g;
	$com =~ s/&quot;/"/g;
	$com =~ s/&amp;/&/g;
	$com =~ s/&#39;/'/g;

	# [{`
	my $mbody = <<"EOM";
$cf{bbs_title}ɓe܂B

eF$date
zXgF$host

  F$in{sub}
OF$in{name}
E-mailF$in{email}
URL   F$in{url}
Yt  F$clip

$com
EOM

	# JISR[hϊ
	$mbody = Jcode->new($mbody,'sjis')->jis;

	# [AhXȂꍇ͊Ǘ҃[ɒu
	$in{email} ||= $cf{mailto};

	# sendmailR}h
	my $scmd = "$cf{sendmail} -t -i";
	if ($cf{sendm_f}) {
		$scmd .= " -f $in{email}";
	}

	# M
	open(MAIL,"| $scmd") or error("Ms");
	print MAIL "To: $cf{mailto}\n";
	print MAIL "From: $in{email}\n";
	print MAIL "Subject: $msub\n";
	print MAIL "MIME-Version: 1.0\n";
	print MAIL "Content-type: text/plain; charset=ISO-2022-JP\n";
	print MAIL "Content-Transfer-Encoding: 7bit\n";
	print MAIL "X-Mailer: $cf{version}\n\n";
	print MAIL "$mbody\n";
	close(MAIL);
}

#-----------------------------------------------------------
#  JPEGTCYF
#-----------------------------------------------------------
sub j_size {
	my $jpg = shift;

	my ($h, $w, $t);
	open(IMG,"$jpg");
	binmode(IMG);
	read(IMG, $t, 2);
	while (1) {
		read(IMG, $t, 4);
		my ($m, $c, $l) = unpack("a a n", $t);

		if ($m ne "\xFF") {
			$w = $h = 0;
			last;
		} elsif ((ord($c) >= 0xC0) && (ord($c) <= 0xC3)) {
			read(IMG, $t, 5);
			($h, $w) = unpack("xnn", $t);
			last;
		} else {
			read(IMG, $t, ($l - 2));
		}
	}
	close(IMG);

	return ($w, $h);
}

#-----------------------------------------------------------
#  GIFTCYF
#-----------------------------------------------------------
sub g_size {
	my $gif = shift;

	my $data;
	open(IMG,"$gif");
	binmode(IMG);
	sysread(IMG, $data, 10);
	close(IMG);

	if ($data =~ /^GIF/) { $data = substr($data, -4); }
	my $w = unpack("v", substr($data, 0, 2));
	my $h = unpack("v", substr($data, 2, 2));

	return ($w, $h);
}

#-----------------------------------------------------------
#  PNGTCYF
#-----------------------------------------------------------
sub p_size {
	my $png = shift;

	my $data;
	open(IMG,"$png");
	binmode(IMG);
	read(IMG, $data, 24);
	close(IMG);

	my $w = unpack("N", substr($data, 16, 20));
	my $h = unpack("N", substr($data, 20, 24));

	return ($w, $h);
}

#-----------------------------------------------------------
#  tb^[
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 쌠\Li폜Eϋ֎~j
	my $copy = <<EOM;
<p style="margin-top:2em;text-align:center;font-family:Verdana,Helvetica,Arial;font-size:11pt;">
- <a href="https://www.kent-web.com/" target="_top">$cf{version}</a> -<br />
++ <a href="https://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  N
#-----------------------------------------------------------
sub autolink {
	my $text = shift;

	$text =~ s/(s?https?:\/\/([\w-.!~*'();\/?:\@=+\$,%#]|&amp;)+)/<a href="$1" target="_blank">$1<\/a>/g;
	return $text;
}

#-----------------------------------------------------------
#  ֎~[h`FbN
#-----------------------------------------------------------
sub no_wd {
	my $flg;
	foreach ( split(/,/, $cf{no_wd}) ) {
		if (index("$in{name} $in{sub} $in{comment}", $_) >= 0) {
			$flg = 1;
			last;
		}
	}
	if ($flg) { error("֎~[h܂܂Ă܂"); }
}

#-----------------------------------------------------------
#  {`FbN
#-----------------------------------------------------------
sub jp_wd {
	if ($in{comment} !~ /[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]/) {
		error("bZ[Wɓ{ꂪ܂܂Ă܂");
	}
}

#-----------------------------------------------------------
#  URL`FbN
#-----------------------------------------------------------
sub urlnum {
	my $com = $in{comment};
	my ($num) = ($com =~ s|(https?://)|$1|ig);
	if ($num > $cf{urlnum}) {
		error("RgURLAhX͍ő$cf{urlnum}܂łł");
	}
}

#-----------------------------------------------------------
#  ANZX
#-----------------------------------------------------------
sub get_host {
	# IP&zXg擾
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}

	# IP`FbN
	my $flg;
	foreach ( split(/\s+/, $cf{deny_addr}) ) {
		s/\./\\\./g;
		s/\*/\.\*/g;

		if ($addr =~ /^$_/i) { $flg = 1; last; }
	}
	if ($flg) {
		error("ANZXĂ܂");

	# zXg`FbN
	} elsif ($host) {

		foreach ( split(/\s+/, $cf{deny_host}) ) {
			s/\./\\\./g;
			s/\*/\.\*/g;

			if ($host =~ /$_$/i) { $flg = 1; last; }
		}
		if ($flg) {
			error("ANZXĂ܂");
		}
	}
	if ($host eq "") { $host = $addr; }
	return ($host,$addr);
}

#-----------------------------------------------------------
#  cryptÍ
#-----------------------------------------------------------
sub encrypt {
	my $in = shift;

	my @wd = ('a'..'z', 'A'..'Z', '0'..'9', '.', '/');
	srand;
	my $salt = $wd[int(rand(@wd))] . $wd[int(rand(@wd))];
	crypt($in,$salt) || crypt ($in,'$1$'.$salt);
}

#-----------------------------------------------------------
#  cryptƍ
#-----------------------------------------------------------
sub decrypt {
	my ($in, $dec) = @_;

	my $salt = $dec =~ /^\$1\$(.*)\$/ ? $1 : substr($dec,0,2);
	if (crypt($in,$salt) eq $dec || crypt($in,'$1$'.$salt) eq $dec) {
		return 1;
	} else {
		return 0;
	}
}

#-----------------------------------------------------------
#  bZ[W
#-----------------------------------------------------------
sub message {
	my $msg = shift;

	open(IN,"$cf{tmpldir}/message.html") or error("open err: message.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/gwbbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!message!/$msg/g;
	$tmpl =~ s/!id!/$in{id}/g;
	$tmpl =~ s/!pw!/$in{pw}/g;

	print "Content-type: text/html; charset=shift_jis\n\n";
	print $tmpl;
	exit;
}

#-----------------------------------------------------------
#  y[WJz{^쐬
#-----------------------------------------------------------
sub make_pgbtn {
	my ($i,$pg) = @_;

	# y[WJz`
	my $next = $pg + $cf{pg_max};
	my $back = $pg - $cf{pg_max};

	# y[WJz{^쐬
	my @pg;
	if ($back >= 0 || $next < $i) {
		my $flg;
		my ($w,$x,$y,$z) = (0,1,0,$i);
		while ($z > 0) {
			if ($pg == $y) {
				$flg++;
				push(@pg,qq!<span class="pg-on"><input type="button" value="$x" style="color:#FFFFFF; background-color: #f3a68c; width:25px; height:22px; font-weight: bold; border:0"></span>\n!);
			} else {
				push(@pg,qq!<span class="pg-off"><input type="submit" name="pg:$y" value="$x" style="color:#9fa09e; background-color: white; width:25px; height:22px; border:0; font-weight: bold; cursor:pointer;"></span>\n!);
			}
			$x++;
			$y += $cf{pg_max};
			$z -= $cf{pg_max};

			if ($flg) { $w++; }
			last if ($w >= 5 && @pg >= 10);
		}
	}
	while( @pg >= 11 ) { shift(@pg); }
	my $ret = join('', @pg);
	if ($back >= 0) {
		$ret = qq!<span class="pg-off"><input type="submit" name="pg:$back" value="&laquo;" style="color:#9fa09e; background-color: white; width:25px; height:22px; border:0; cursor:pointer;"></span>\n! . $ret;
	}
	if ($next < $i) {
		$ret .= qq!<span class="pg-off"><input type="submit" name="pg:$next" value="&raquo;" style="color:#9fa09e; background-color: white; width:25px; height:22px; border:0; cursor:pointer;"></span>\n!;
	}
	$ret;
}

#-----------------------------------------------------------
#  NbL[s
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# tH[}bg
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLGR[h
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: $cf{cookie_id}=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  NbL[擾
#-----------------------------------------------------------
sub get_cookie {
	# NbL[擾
	my $cook = $ENV{HTTP_COOKIE};

	# YIDo
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLfR[h
	my @cook;
	foreach ( split(/<>/, $cook{$cf{cookie_id}}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  F
#-----------------------------------------------------------
sub check_passwd {
	# tH[͂̃`FbN
	if ($in{id} eq "" || $in{pw} eq "") {
		enter_form();
	}

	# F
	my $flg;
	foreach (@{$cf{passwd}}) {
		my ($id,$pw) = split(/:/);

		if ($in{id} eq $id && $in{pw} eq $pw) {
			$flg++;
			last;
		}
	}
	error("F؂ł܂") if (!$flg);

	# NbL[L
	if ($in{login} == 1) { set_entcook(); }
}

#-----------------------------------------------------------
#  
#-----------------------------------------------------------
sub enter_form {
	# NbL[擾
	my ($id,$pw) = get_entcook();

	open(IN,"$cf{tmpldir}/enter.html") or error("open err: enter.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!bbs_cgi!/$cf{bbs_cgi}/g;
	$tmpl =~ s/!bbs_title!/$cf{bbs_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/gwbbs.css|g;
	$tmpl =~ s|!bbs_js!|$cf{cmnurl}/bbs.js|g;
	$tmpl =~ s/!id!/$id/;
	$tmpl =~ s/!pw!/$pw/;
	if ($id ne '' && $pw ne '') {
		$tmpl =~ s|<input type="checkbox" name="cook"([^<>]+)>|<input type="checkbox" name="cook" checked="checked" $1>|;
	}

	print "Content-type: text/html; charset=shift_jis\n\n";
	footer($tmpl);
}

#-----------------------------------------------------------
#  pX[h擾
#-----------------------------------------------------------
sub get_entcook {
	# NbL[擾
	my $cook = $ENV{HTTP_COOKIE};

	# YIDo
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}
	$cook{$cf{entcok_id}} =~ s/\W//g;
	
	# oCi֖߂
	$cook{$cf{entcok_id}} =~ s/n/\n/g;
	$cook{$cf{entcok_id}} =~ s/([0-9A-Fa-f]{2})/pack('H2',$1)/eg;
	
	# RC4
	my $plain = RC4($cf{crypt_key},$cook{$cf{entcok_id}});
	
	return split(/:/,$plain);
}

#-----------------------------------------------------------
#  pX[hL
#-----------------------------------------------------------
sub set_entcook {
	if ($in{cook} != 1) {
		print "Set-Cookie: $cf{entcok_id}=; expires=Thu, 1-Jan-1970 00:00:00 GMT;\n";
		
	} else {
		# RC4Íϊ
		my $crypt = RC4($cf{crypt_key},"$in{id}:$in{pw}");

		# oCi16i
		$crypt =~ s/(.)/unpack('H2',$1)/eg;
		$crypt =~ s/\n/n/g;

		# 60ԗL
		my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
		my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
		my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

		# tH[}bg
		my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
						$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

		print "Set-Cookie: $cf{entcok_id}=$crypt; expires=$gmt\n";
	}
}

#-----------------------------------------------------------
#  t@Ce
#-----------------------------------------------------------
sub get_size {
	my $file = shift;
	
	my $size = -s $file || 0;
	return $size > 1024 ? comma(int($size/1024)) . 'KB' : $size . 'Bytes';
}

#-----------------------------------------------------------
#  ؂
#-----------------------------------------------------------
sub comma {
	local($_) = @_;

	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

#-----------------------------------------------------------
#  t@C`FbN
#-----------------------------------------------------------
sub check_upl {
	my ($ext) = @_;

	# mime^Cv
	my $mime = $cgi->param_mime('upfile');

	my $flg;
	if ($cf{ok_gif}) {
		if ($mime =~ /^image\/gif$/i and $ext eq '.gif') { $flg++; }
	}
	if (!$flg and $cf{ok_jpeg}) {
		if ($mime =~ /^image\/p?jpe?g$/i and $ext eq '.jpg') { $flg++; }
	}
	if (!$flg and $cf{ok_pdf}) {
		if ($mime =~ /^application\/pdf$/i and $ext eq '.pdf') { $flg++; }
	}
	if (!$flg and $cf{ok_zip}) {
		if ($mime =~ /^application\/(x-)?zip(-compressed)?$/i and $ext eq '.zip') { $flg++; }
	}
	if (!$flg and $cf{ok_text}) {
		if ($mime =~ /^text\/plain$/i and $ext =~ /^\.te?xt$/) { $flg++; }
	}
	if (!$flg and $cf{ok_word}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?word$/i and $ext eq '.doc') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.wordprocessingml\.document$/i and $ext eq '.docx') { $flg++; }
	}
	if (!$flg and $cf{ok_excel}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?excel$/i and $ext eq '.xls') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.spreadsheetml\.sheet$/i and $ext eq '.xlsx') { $flg++; }
	}
	if (!$flg and $cf{ok_ppt}) {
		if ($mime =~ /^application\/(vnd\.)?ms-?powerpoint$/i and $ext eq '.ppt') { $flg++; }
		elsif ($mime =~ /^application\/vnd\.openxmlformats-officedocument\.presentationml\.presentation$/i and $ext eq '.pptx') { $flg++; }
	}

	if (!$flg) { error('̃t@C͎舵ł܂'); }
}

